# MatZeroRows

Zeros all entries (except possibly the main diagonal) of a set of rows of a matrix.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatZeroRows(Mat mat,PetscInt numRows,const PetscInt rows[],PetscScalar diag)

Collective on Mat

### Input Parameters

| mat | - the matrix
| numRows | - the number of rows to remove
| rows | - the global row indices
| diag | - value put in all diagonals of eliminated rows

### Notes

For the AIJ and BAIJ matrix formats this removes the old nonzero structure, but does not release memory. For the dense and block diagonal formats this does not alter the nonzero structure.

If the option MatSetOption(mat,MAT_KEEP_ZEROED_ROWS) the nonzero structure of the matrix is not changed (even for AIJ and BAIJ matrices) the values are merely zeroed.

The user can set a value in the diagonal entry (or for the AIJ and row formats can optionally remove the main diagonal entry from the nonzero structure as well, by passing 0.0 as the final argument).

For the parallel case, all processes that share the matrix (i.e., those in the communicator used for matrix creation) MUST call this routine, regardless of whether any rows being zeroed are owned by them.

Each processor should list the rows that IT wants zeroed

### See Also

MatZeroRowsIS(), MatZeroEntries(), MatZeroRowsLocal(), MatSetOption()

Level:intermediate
Location:src/mat/interface/matrix.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/ksp/ksp/examples/tutorials/ex3.c.html
src/ksp/ksp/examples/tutorials/ex33.c.html